; Code by Elmar Hanlhofer, 20081021, simple boot manager loader
; update 20081207: check for destination segment

model tiny
p386n
codeseg
assume es:nothing
        startupcode

    mov eax,-1  ;54e11bbh    ;-1
    mov ebx,-1

    mov cx,cs
    mov ds,cx
    mov ss,cx
    mov sp,-1

    ; simple destination segment selection
    mov [destseg],4000h
    cmp cx,5000h
    jae _segmentok
    mov [destseg],6000h
_segmentok:
    pushad

        mov ah,0eh
        mov al,"x"
        mov bx,7
        int 10h

    popad

    mov dx,[destseg]

    mov cx,3
    lea si,[diskExtentionPacket]
    mov [byte ptr si+0],10h
    mov [byte ptr si+1],0h
    mov [word ptr si+2],60h
    mov [word ptr si+4],100h
    mov [word ptr si+6],dx
    mov [dword ptr si+8],eax
    mov [dword ptr si+12],ebx

    mov ah,42h
    mov dl,80h
_loop:
    pusha
        int 13h
        jnc _nerr

        xor ax,ax
        int 13h
    popa
    loop _loop

    mov ah,0eh
    mov al,"e"
    mov bx,7
    int 10h

_endless:
    xor ax,ax
    int 16h
    jmp _endless

_nerr:


    mov ah,0eh
    mov al,"o"
    mov bx,7
    int 10h

    mov eax,"NTBT"  ; tell that windows boot sector start the program
    mov edi,"TBTN"

    push [destseg]
    push 100h
    retf
;int 3

;    int 20h


diskExtentionPacket     db 10h dup (?)
destseg                 dw ?



