/*
 * code by Elmar Hanlhofer 20081021
 *
 * this is a minimal program to get the cluster of a program on a
 * ntfs partition
 *
 * 20081207: SetFilePointerEx update
 *
 */

#include "stdio.h"
#include "windows.h"
#include "winioctl.h"


#define INODESIZE 1024

void dumpBuffer (int nr,char *b, int i)
{
    FILE *pf;
    char name[1024];
    sprintf (name,"dump%d.bin",nr);
    
    
    pf=fopen (name,"wb");
    fwrite (b,i,1,pf);
    fclose (pf);


}

int hdRead (LARGE_INTEGER pos, char *buffer, int bytes)
{
    char _devicename[] = "\\\\.\\C:";
    HANDLE hDevice ;
    DWORD bytesread;


    hDevice = CreateFile(_devicename,
        GENERIC_READ|GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE,
        NULL, OPEN_EXISTING, 0, NULL);

    if (hDevice == INVALID_HANDLE_VALUE) {
        printf ("Device error\r\n");
        return 1;
    }

    if (!SetFilePointerEx (hDevice,pos,0,0))
	printf ("Seek error\n");

    if (!ReadFile(hDevice, buffer, bytes, &bytesread, 0)) {
        printf ("Read error\r\n");
        CloseHandle(hDevice);
        return 1;
    }
    CloseHandle(hDevice);

    return 0;
}

int hdReadCluster (LARGE_INTEGER pos, char *buffer, int bytes, int clusterspersector,long moveto)
{
    char _devicename[] = "\\\\.\\C:";
    HANDLE hDevice ;
    DWORD bytesread;


    hDevice = CreateFile(_devicename,
        GENERIC_READ|GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE,
        NULL, OPEN_EXISTING, 0, NULL);

    if (hDevice == INVALID_HANDLE_VALUE) {
        printf ("Device error\r\n");
        return 1;
    }

    if (!SetFilePointerEx (hDevice,pos,0, FILE_CURRENT))
        printf ("Seek error\n");

    if (!ReadFile(hDevice, buffer, bytes, &bytesread,0)) {
        printf ("Read error\r\n");
        CloseHandle(hDevice);
        return 1;
    }
    CloseHandle(hDevice);

    return 0;
}


void loadRootdirLCN (char *buffer,unsigned long int *lcn,unsigned long int *clusters)
{
    int ofs;
    int type=0;
    unsigned long int check=0;
    int i,i2,l1,l2;
    long tmpclusters,tmplcn,tmplcn2,tmpsub;

//dumpBuffer (99,buffer,1024);
    ofs=buffer[0x14];    
    while (check!=0xffffffff) {
	type=buffer[ofs] & 0xff;
	
	if (type==0xa0) {
	    ofs+=10;
	    ofs+=buffer[ofs] & 0xff;
	    ofs-=2;
	    //printf ("s %x\n",ofs);	    


	    i2=0;
	    tmplcn=tmplcn2=0;
	    clusters[i2]=lcn[i2]=0;

	    while (buffer[ofs]!=0x00) {

		l1=buffer[ofs] & 0x0f;
		l2=buffer[ofs] >> 4;
	    
	        tmpclusters=0;
		for (i=0;i<l1;i++) {
		    ofs++;
		    tmpclusters+=(buffer[ofs] & 0xff) << (i*8);	    
		}
	    
		tmplcn=0;
		tmpsub=0;
		for (i=0;i<l2;i++) {
		    ofs++;
		    tmplcn+=(buffer[ofs] & 0xff) << (i*8);	    
		    tmpsub+=0xff << (i*8);
		}
		if (buffer[ofs] & 0x80) tmplcn2+=(tmplcn-tmpsub-tmpclusters);
		else tmplcn2+=tmplcn;
	    
		printf ("loadrootdir: clusters %x lcn %x %d\n",tmpclusters,tmplcn2,tmplcn2);
		lcn[i2]=tmplcn2;
		clusters[i2]=tmpclusters;
		i2++;
		ofs++;

		clusters[i2]=lcn[i2]=0;

	    }
	    
	    return;

	}	

	ofs+=(buffer[ofs+4] & 0xff) +
	     ((buffer[ofs+5] & 0xff) << 8);

	
	check=(buffer[ofs] & 0xff) +
	      ((buffer[ofs+1] & 0xff) << 8)+
	      ((buffer[ofs+2] & 0xff) << (8*2)) +
	      ((buffer[ofs+3] & 0xff) << (8*3));
    }

}

void loadLCN (char *buffer,unsigned long int *lcn,unsigned long int *clusters)
{
    int ofs;
    int type=0;
    unsigned long int check=0;
    int l1,l2,i;
    int tmpclusters,tmplcn,tmplcn2,tmpsub;
    int i2;


    ofs=buffer[0x14];    
    while (check!=0xffffffff) {
	type=buffer[ofs] & 0xff;
	    printf ("mft: attribute type 0x%x\n",type);	    
	
	if (type==0x80) {
	    //ofs+=10;
	    ofs+=buffer[ofs+0x20] & 0xff;
	    printf ("mft: attribute offset 0x%x\n",ofs);	    

	    i2=0;
	    tmplcn=tmplcn2=0;
	    clusters[i2]=lcn[i2]=0;
	    tmplcn=0;
	    while (buffer[ofs]!=0x00) {

		l1=buffer[ofs] & 0x0f;
		l2=buffer[ofs] >> 4;
	    
	        tmpclusters=0;
		for (i=0;i<l1;i++) {
		    ofs++;
		    tmpclusters+=(buffer[ofs] & 0xff) << (i*8);	    
		}
	    
	    
		tmplcn=0;
		tmpsub=0;
		for (i=0;i<l2;i++) {
		    ofs++;
		    tmplcn+=(buffer[ofs] & 0xff) << (i*8);	    
		    tmpsub+=0xff << (i*8);
		}
		if (buffer[ofs] & 0x80) tmplcn2+=(tmplcn-tmpsub-tmpclusters);
		else tmplcn2+=tmplcn;
	    
		printf ("loadLCN: cluster 0x%x lcn 0x%x %d\n",tmpclusters,tmplcn2,tmplcn2);
		lcn[i2]=tmplcn2;
		clusters[i2]=tmpclusters;
		i2++;
		ofs++;

		clusters[i2]=lcn[i2]=0;


	    }
	    
	    return;
	}	

	ofs+=(buffer[ofs+4] & 0xff) +
	     ((buffer[ofs+5] & 0xff) << 8);

	
	check=(buffer[ofs] & 0xff) +
	      ((buffer[ofs+1] & 0xff) << 8)+
	      ((buffer[ofs+2] & 0xff) << (8*2)) +
	      ((buffer[ofs+3] & 0xff) << (8*3));
    }

}

int charcmp (char *s1, char *s2, int len)
{
    int i;

    for (i=0;i<len;i++) 
	if (s1[i]!=s2[i]) return 0;
	
    return 1;
}


long getFileInode (char *filename,int len,char *buffer)
{
    int ofs;
    long inode=-1;
    
    ofs=0x18;
    ofs+=buffer[ofs] & 0xff;
    
    int i=40;
    while (i--) {
	inode=(buffer[ofs] & 0xff) +
	      ((buffer[ofs+1] & 0xff) << 8)+
	      ((buffer[ofs+2] & 0xff) << (8*2)) +
	      ((buffer[ofs+3] & 0xff) << (8*3));


	//printf ("inode %x\n",inode);
	//printf ("b %x\n",buffer[ofs+8] & 0xff);
	//printf ("f %x\n",buffer[ofs+10] & 0xff);
	//printf ("ofs %x\n",ofs);

	if ((buffer[ofs+8] & 0xff) == 0x10) return 0;
	if (charcmp(filename,buffer+ofs+0x52,len)) {
	//(buffer[ofs+10] & 0xff)-2,len)) {
	    printf ("file found, inode=%d\n",inode);
	    return inode;
	}

	ofs+=buffer[ofs+8] & 0xff;
    }

    return 0;
}


int main(int argc,char **argv[])
{
#include "Q.str"    


    char bootsector[512];
    unsigned long mftstartcluster;
    unsigned short sectorspercluster;
    char inode_rootdirectory[INODESIZE];
    char inode_mft[INODESIZE];
    LARGE_INTEGER pos,pos2;
    char directoryBuffer[512*32];
    char fileBuffer[1024];
    char filename[]={'p',0,'l',0,'p',0,'b',0,'t',0,'.',0,'b',0,'i',0,'n',0};
    int inode;

    unsigned long rootdirLCN[30];
    unsigned long rootdirClusters[30];
    unsigned long mftLCN[30];
    unsigned long mftClusters[30];
    unsigned long fileLCN[30];
    unsigned long fileClusters[30];
    int i,i2;


    char ldrbuffer[LDRSIZE];
        
    FILE *pf;


    printf ("plpgenbtldr v0.5 20081217 generate ntfs loader, by Elmar Hanlhofer\n\n");

    printf ("***************************************\n");
    printf ("debug infos:\n");

    /************************************************/

    pos.QuadPart=0;
    hdRead (pos,bootsector,512);
    
    if (strncmp (bootsector+3,"NTFS",4)!=0) {
	printf ("\nError: only NTFS is supported!\n\n");
	exit (1);
    }

    sectorspercluster=bootsector[0x0d];

    // TODO MFT START CLUSTER IS QWORD AND NOT DWORD
    mftstartcluster= (bootsector[0x30] & 0xff) +
		((bootsector[0x31] & 0xff) << 8) +
		((bootsector[0x32] & 0xff) << (8*2)) +
		((bootsector[0x33] & 0xff) << (8*3));

    printf ("mft start cluster %x, sectors per cluster %d\n",mftstartcluster,sectorspercluster);


    fileLCN[0]=0;
    
    if (argc==2) {
	if (strncmp (argv[1],"lcn=",4)==0) {
	    strcpy (fileBuffer,argv[1]);
	    fileLCN[0]=atoi (fileBuffer+4);
	    fileClusters[0]=0;
	
	}
	
	
    }
    /************************************************/

    if (fileLCN[0]==0) {

    pos.QuadPart=mftstartcluster*sectorspercluster*512+5*INODESIZE;
    hdRead (pos,inode_rootdirectory,INODESIZE);
//dumpBuffer (inode_rootdirectory,INODESIZE);
//exit(0);    
    
    loadRootdirLCN (inode_rootdirectory,rootdirLCN,rootdirClusters);
    
//dumpBuffer (inode_rootdirectory,INODESIZE);
//exit(0);    

    i=0;
    inode=0;

    while ((rootdirLCN[i]!=0) && !inode) {
	i2=0;
	while ((i2<rootdirClusters[i]) && !inode) {
	    pos.QuadPart=rootdirLCN[i]+i2;
	    pos.QuadPart*=512;
	    pos.QuadPart*=sectorspercluster;
	    
	    
	    hdReadCluster (pos,directoryBuffer,512*sectorspercluster,sectorspercluster,rootdirLCN[i]+i2);
	    inode=getFileInode (filename,sizeof (filename),directoryBuffer);
	    //printf ("rr %d\n",rootdirLCN[i]);
	    i2++;
	    
	}
	
	i++;
    }
    if (!inode) {
	printf ("file c:\\plpbt.bin not found\n");
	printf ("Workaround: see 1README.TXT or http://www.plop.at\n");
	
	return (1);
    }
    /************************************************/

    pos.QuadPart=mftstartcluster;
    pos.QuadPart*=sectorspercluster;
    pos.QuadPart*=512;
    
    
    hdRead (pos,inode_mft,INODESIZE);
    //dumpBuffer(inode_mft,512*2);
    loadLCN (inode_mft,mftLCN,mftClusters);

    //printf ("dd %d %d\n",mftClusters[0]*sectorspercluster/2,inode);

    fileLCN[0]=-1;
    
    if (mftClusters[0]*sectorspercluster/2>inode) {
	
	pos.QuadPart=mftLCN[0];
	pos.QuadPart*=sectorspercluster;
	pos.QuadPart*=512;
	
	pos2.QuadPart=inode;
	pos2.QuadPart*=INODESIZE;
	
	pos.QuadPart+=pos2.QuadPart;
	
	hdRead (pos,fileBuffer,1024);
	loadLCN (fileBuffer,fileLCN,fileClusters);
    
    
    
    } else {
	inode=(inode-mftClusters[0]*sectorspercluster/2);
	pos.QuadPart=mftLCN[1];
	pos.QuadPart*=sectorspercluster;
	pos.QuadPart*=512;
	
	pos2.QuadPart=inode;
	pos2.QuadPart*=INODESIZE;
	
	pos.QuadPart+=pos2.QuadPart;
	
	hdRead (pos,fileBuffer,1024);
	loadLCN (fileBuffer,fileLCN,fileClusters);    
    }

    if (fileLCN[0]==-1) {
	printf ("error loading cluster number\n");
	return 1;    
    }


    } // if fileLCN[0]==0 
    
    printf ("\nFile infos: LCN %x %d, Clusters %d\n",fileLCN[0],fileLCN[0],fileClusters[0]);
    
    if (fileLCN[1]!=0) {
	printf ("Error, c:\\plpbt.bin is fragmented! Try to copy the file again to c:\\\n");
	printf ("If this does not help, defrag your drive c:\n\n");
	exit(1);    
    }


    /************************************************/


    for (i=0;i<LDRSIZE;i++)
	ldrbuffer[i]=ldr[i];
	
    

    if (!(pf=fopen ("plpbtldr.bin","wb"))) {
	printf ("cannot create plpbtldr.bin\n");
	return 1;
    }




    pos.QuadPart=fileLCN[0];
    pos.QuadPart*=sectorspercluster;

    pos2.QuadPart=bootsector[0x1c] & 0xff;
    pos2.QuadPart+=((bootsector[0x1d] & 0xff) << 8);
    pos2.QuadPart+=((bootsector[0x1e] & 0xff) << (8*2));
    pos2.QuadPart+=((bootsector[0x1f] & 0xff) << (8*3));

    pos.QuadPart+=pos2.QuadPart;
    
    
    printf ("File LBA: 0x%0x\n",pos.QuadPart);
    
    for (i=0;i<4;i++) 
	ldrbuffer[0x02+i]=(pos.QuadPart >> (i*8)) & 0xff;
    
    for (i=4;i<8;i++) 
	ldrbuffer[0x08+i-4]=(pos.QuadPart >> (i*8)) & 0xff;
    




    fwrite (ldrbuffer,1,LDRSIZE,pf);


    fclose (pf);
    
    printf ("\n\n***************************************\n\n");
    printf ("plpbtldr.bin created.\n\n");
    printf (" Windows XP users: add the line below to your boot.ini\n");
    printf (" c:\\plpbtldr.bin=\"Start PLoP Boot Manager\"\n\n");
    printf (" Windows VISTA: please read the documentation in the 1README.TXT file\n");
    printf (" or online at http://www.plop.at\n\n");


    //dumpBuffer(0,directoryBuffer,512*sectorspercluster);
    //dumpBuffer(0,inode_rootdirectory,INODESIZE);
    //dumpBuffer(0,fileBuffer,INODESIZE);


    return 0;

}


